package io.gitlab.jfronny.dynres;

import io.gitlab.jfronny.libjf.web.api.WebInit;
import io.gitlab.jfronny.libjf.web.api.WebServer;
import net.fabricmc.api.EnvType;
import net.fabricmc.loader.api.FabricLoader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

public class DynRes implements WebInit {
    public static final Logger LOGGER = LoggerFactory.getLogger("DynRes");
    public static Path packFile;
    public static String packUrl = "";

    static {
        packFile = FabricLoader.getInstance().getGameDir().resolve(Cfg.resourcesFile);
        if (!Files.exists(packFile)) {
            if (FabricLoader.getInstance().getEnvironmentType() == EnvType.SERVER) {
                LOGGER.error("The resource file specified in your config could not be found. YOU MUST SPECIFY A RESOURCE PACK FOR IT TO BE SERVED!");
            }
            packFile = null;
        }
    }

    @Override
    public void register(WebServer api) {
        if (FabricLoader.getInstance().getEnvironmentType() == EnvType.SERVER && packFile != null) {
            try {
                packUrl = api.registerFile("/resources.zip", packFile, !Cfg.hashResources);
                LOGGER.info("Initialized DynRes at " + packUrl);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
